import { CommonModule } from '@angular/common';
import { takeUntil } from 'rxjs/operators';
import { __spread } from 'tslib';
import { EventEmitter, Injectable, ChangeDetectorRef, Directive, Inject, Input, ViewContainerRef, NgModule } from '@angular/core';
import { BehaviorSubject, isObservable, Observable, ReplaySubject, Subject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var defaultNgxBindIOConfig = {
    debug: false
};
/** @type {?} */
var NGX_BIND_IO_CONFIG = 'NgxBindIOConfig';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var values = new WeakMap();
/**
 * @param {?} instance
 * @return {?}
 */
function valueMap(instance) {
    /** @type {?} */
    var _valueMap = values.get(instance);
    if (!_valueMap) {
        _valueMap = new Map();
        values.set(instance, _valueMap);
    }
    return _valueMap;
}
/**
 * @param {?} target
 * @param {?} propertyKey
 * @param {?=} callback
 * @return {?}
 */
function redefineSimpleProperty(target, propertyKey, callback) {
    Object.defineProperty(target, propertyKey, {
        configurable: true,
        enumerable: true,
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            valueMap(this).set(propertyKey, value);
            if (callback) {
                callback(value);
            }
        },
        get: /**
         * @return {?}
         */
        function () {
            return valueMap(this).get(propertyKey);
        }
    });
}
/**
 * @param {?} target
 * @param {?} propertyKey
 * @param {?} descriptor
 * @param {?=} callback
 * @return {?}
 */
function redefineAccessorProperty(target, propertyKey, descriptor, callback) {
    Object.defineProperty(target, propertyKey, {
        configurable: descriptor.configurable,
        enumerable: descriptor.enumerable,
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!descriptor.set) {
                throw new Error("Property " + propertyKey + " doesn't have a setter and cannot be written");
            }
            descriptor.set.call(this, value);
            if (!descriptor.get) {
                callback(value);
            }
            else {
                callback(descriptor.get());
            }
        },
        get: /**
         * @return {?}
         */
        function () {
            if (!descriptor.get) {
                throw new Error("Property " + propertyKey + " doesn't have a getter and cannot be read");
            }
            return descriptor.get.call(this);
        }
    });
}
/**
 * @param {?} target
 * @param {?} propertyKey
 * @return {?}
 */
function getPropDescriptor(target, propertyKey) {
    /** @type {?} */
    var originalDescriptor = Reflect.getOwnPropertyDescriptor(target, propertyKey);
    /** @type {?} */
    var setter = originalDescriptor && originalDescriptor.set;
    /** @type {?} */
    var getter = originalDescriptor && originalDescriptor.get;
    /** @type {?} */
    var value = originalDescriptor ? originalDescriptor.value : target[propertyKey];
    if (!setter || ((/** @type {?} */ (target))).__lookupSetter__(propertyKey)) {
        setter = ((/** @type {?} */ (target))).__lookupSetter__(propertyKey);
    }
    if (!getter || ((/** @type {?} */ (target))).__lookupGetter__(propertyKey)) {
        getter = ((/** @type {?} */ (target))).__lookupGetter__(propertyKey);
    }
    if (!originalDescriptor && setter && getter) {
        originalDescriptor = {
            configurable: true,
            enumerable: true,
            set: setter.bind(target),
            get: getter.bind(target)
        };
    }
    return {
        originalDescriptor: originalDescriptor,
        value: value,
        setter: setter,
        getter: getter
    };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} functionToCheck
 * @return {?}
 */
function isFunction(functionToCheck) {
    return functionToCheck && {}.toString.call(functionToCheck) === '[object Function]';
}
/**
 * @param {?} derivedCtor
 * @param {?} baseCtors
 * @return {?}
 */
function applyMixins(derivedCtor, baseCtors) {
    baseCtors.forEach(function (baseCtor) {
        Object.getOwnPropertyNames(baseCtor.prototype).forEach(function (name) {
            derivedCtor.prototype[name] = baseCtor.prototype[name];
        });
    });
    return derivedCtor;
}
/**
 * @param {?} baseCtors
 * @return {?}
 */
function Mixin(baseCtors) {
    return function (derivedCtor) {
        baseCtors.forEach(function (baseCtor) {
            Object.getOwnPropertyNames(baseCtor.prototype).forEach(function (name) {
                derivedCtor.prototype[name] = baseCtor.prototype[name];
            });
        });
    };
}
/**
 * @param {?} component
 * @param {?} rule
 * @param {?=} maxLevel
 * @return {?}
 */
function collectKeys(component, rule, maxLevel) {
    if (maxLevel !== undefined) {
        maxLevel--;
        if (maxLevel === 0) {
            return [];
        }
    }
    /** @type {?} */
    var keys = component ? Object.keys(component).filter(function (key) { return rule(component, key); }) : [];
    if (component && component.__proto__) {
        keys = __spread(keys, collectKeys(component.__proto__, rule, maxLevel));
    }
    return keys;
}
/**
 * @param {?} directive
 * @param {?} existsKeys
 * @return {?}
 */
function removeKeysUsedInAttributes(directive, existsKeys) {
    /** @type {?} */
    var viewContainerRef = (/** @type {?} */ (((/** @type {?} */ (directive)))._viewContainerRef));
    if (viewContainerRef &&
        viewContainerRef.element &&
        viewContainerRef.element.nativeElement &&
        viewContainerRef.element.nativeElement.attributes) {
        /** @type {?} */
        var attributes_1 = (/** @type {?} */ (viewContainerRef.element.nativeElement.attributes));
        return existsKeys.filter(function (key) {
            /** @type {?} */
            var founded = false;
            for (var i = 0; i < attributes_1.length; i++) {
                /** @type {?} */
                var name_1 = attributes_1
                    .item(i)
                    .name.replace(new RegExp('-', 'g'), '')
                    .toUpperCase();
                if (key.replace(new RegExp('-', 'g'), '').toUpperCase() === name_1) {
                    founded = true;
                }
            }
            return !founded;
        });
    }
    return existsKeys;
}
/**
 * @param {?} component
 * @return {?}
 */
function getBindIOMetadata(component) {
    if (!component['__bindIO__']) {
        ((/** @type {?} */ (component['__bindIO__']))) = {
            asHost: {
                subjects: {}
            },
            asInner: {
                subscriptions: {}
            }
        };
    }
    return (/** @type {?} */ (component['__bindIO__']));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBindInputsService = /** @class */ (function () {
    function NgxBindInputsService() {
    }
    /**
     * BindInputs Directive
     */
    /**
     * BindInputs Directive
     * @param {?} directive
     * @return {?}
     */
    NgxBindInputsService.prototype.bindInputs = /**
     * BindInputs Directive
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        var _this = this;
        /** @type {?} */
        var inputs = directive.inputs;
        var _a = this.getIncludesAndExcludes(directive), includeInputs = _a.includeInputs, excludeInputs = _a.excludeInputs;
        inputs.parentKeys
            .filter(function (parentKey) {
            return (includeInputs.length === 0 && excludeInputs.indexOf(parentKey.toUpperCase()) === -1) ||
                (includeInputs.length !== 0 && includeInputs.indexOf(parentKey.toUpperCase()) !== -1);
        })
            .forEach(function (parentKey) {
            inputs.keys
                .filter(function (key) {
                return (includeInputs.length === 0 && excludeInputs.indexOf(key.toUpperCase()) === -1) ||
                    (includeInputs.length !== 0 && includeInputs.indexOf(key.toUpperCase()) !== -1);
            })
                .forEach(function (key) {
                if (_this.checkInputToBind(directive, parentKey, key)) {
                    _this.bindInput(directive, parentKey, key);
                }
            });
        });
    };
    /**
     * @param {?} directive
     * @return {?}
     */
    NgxBindInputsService.prototype.bindObservableInputs = /**
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        var _this = this;
        /** @type {?} */
        var inputs = directive.inputs;
        var _a = this.getIncludesAndExcludes(directive), includeInputs = _a.includeInputs, excludeInputs = _a.excludeInputs;
        inputs.parentKeys
            .filter(function (parentKey) {
            return (includeInputs.length === 0 && excludeInputs.indexOf(parentKey.toUpperCase()) === -1) ||
                (includeInputs.length !== 0 && includeInputs.indexOf(parentKey.toUpperCase()) !== -1);
        })
            .forEach(function (parentKey) {
            inputs.keys
                .filter(function (key) {
                return (includeInputs.length === 0 && excludeInputs.indexOf(key.toUpperCase()) === -1) ||
                    (includeInputs.length !== 0 && includeInputs.indexOf(key.toUpperCase()) !== -1);
            })
                .forEach(function (key) {
                if (_this.checkObservableInputToBind(directive, parentKey, key)) {
                    _this.bindObservableInput(directive, parentKey, key);
                }
            });
        });
    };
    /**
     * Inputs
     */
    /**
     * Inputs
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindInputsService.prototype.checkKeyNameToInputBind = /**
     * Inputs
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        return parentKey === key && parentKey[0] !== '_';
    };
    /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindInputsService.prototype.checkInputToBind = /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        /** @type {?} */
        var parentValue = getPropDescriptor(directive.parentComponent, parentKey).value || directive.parentComponent[parentKey];
        return (directive.usedInputs[parentKey] === undefined &&
            !isObservable(parentValue) &&
            this.checkKeyNameToInputBind(directive, parentKey, key));
    };
    /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindInputsService.prototype.bindInput = /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        directive.usedInputs[parentKey] = key;
        /** @type {?} */
        var descriptor = getPropDescriptor(directive.parentComponent, parentKey);
        /** @type {?} */
        var currentValue = descriptor.value || directive.parentComponent[parentKey];
        if (!getBindIOMetadata(directive.parentComponent).asHost[parentKey]) {
            getBindIOMetadata(directive.parentComponent).asHost[parentKey] = new Subject();
            delete directive.parentComponent[parentKey];
            if (descriptor !== undefined && descriptor.setter !== undefined && descriptor.getter !== undefined) {
                redefineAccessorProperty(directive.parentComponent, parentKey, descriptor.originalDescriptor, function (newValue) {
                    return getBindIOMetadata(directive.parentComponent).asHost[parentKey].next(newValue);
                });
            }
            else {
                redefineSimpleProperty(directive.parentComponent, parentKey, function (newValue) {
                    return getBindIOMetadata(directive.parentComponent).asHost[parentKey].next(newValue);
                });
            }
        }
        getBindIOMetadata(directive.parentComponent)
            .asHost[parentKey].pipe(takeUntil(directive.destroyed$))
            .subscribe(function (value) { return directive.bindValue(key, value); });
        directive.parentComponent[parentKey] = currentValue;
    };
    /**
     * Observable Inputs
     */
    /**
     * Observable Inputs
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindInputsService.prototype.checkKeyNameToObservableInputBind = /**
     * Observable Inputs
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        return parentKey === key + "$" && parentKey[0] !== '_';
    };
    /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindInputsService.prototype.checkObservableInputToBind = /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        /** @type {?} */
        var parentValue = getPropDescriptor(directive.parentComponent, parentKey).value || directive.parentComponent[parentKey];
        return (directive.usedInputs[parentKey] === undefined &&
            isObservable(parentValue) &&
            this.checkKeyNameToObservableInputBind(directive, parentKey, key));
    };
    /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindInputsService.prototype.bindObservableInput = /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        directive.usedInputs[parentKey] = key;
        /** @type {?} */
        var descriptor = getPropDescriptor(directive.parentComponent, parentKey);
        /** @type {?} */
        var isBehaviorSubject = descriptor.value instanceof BehaviorSubject;
        /** @type {?} */
        var currentValue = descriptor.value || directive.parentComponent[parentKey];
        /** @type {?} */
        var behaviorSubjectValue;
        if (descriptor.value instanceof BehaviorSubject) {
            behaviorSubjectValue = descriptor.value.getValue();
        }
        if (!getBindIOMetadata(directive.parentComponent).asHost[parentKey]) {
            getBindIOMetadata(directive.parentComponent).asHost[parentKey] = new Subject();
            delete directive.parentComponent[parentKey];
            if (descriptor !== undefined && descriptor.setter !== undefined && descriptor.getter !== undefined) {
                redefineAccessorProperty(directive.parentComponent, parentKey, descriptor.originalDescriptor, function (newValue) {
                    return getBindIOMetadata(directive.parentComponent).asHost[parentKey].next(newValue);
                });
            }
            else {
                redefineSimpleProperty(directive.parentComponent, parentKey, function (newValue) {
                    return getBindIOMetadata(directive.parentComponent).asHost[parentKey].next(newValue);
                });
            }
        }
        getBindIOMetadata(directive.parentComponent)
            .asHost[parentKey].pipe(takeUntil(directive.destroyed$))
            .subscribe(function (newValue) {
            if (newValue instanceof Observable) {
                if (getBindIOMetadata(directive.component).asInner[parentKey]) {
                    getBindIOMetadata(directive.component).asInner[parentKey].unsubscribe();
                }
                getBindIOMetadata(directive.component).asInner[parentKey] = newValue
                    .pipe(takeUntil(directive.destroyed$))
                    .subscribe(function (value) { return directive.bindValue(key, value); });
            }
        });
        try {
            directive.parentComponent[parentKey] = currentValue;
        }
        catch (error) { }
        if (isBehaviorSubject) {
            currentValue.next(behaviorSubjectValue);
        }
    };
    /**
     * Utils
     */
    /**
     * Utils
     * @param {?} directive
     * @return {?}
     */
    NgxBindInputsService.prototype.getInputs = /**
     * Utils
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        /** @type {?} */
        var foundedInputs = {
            parentKeys: collectKeys(directive.parentComponent, function (cmp, key) {
                return !isFunction(getPropDescriptor(directive.component, key).value) || !isFunction(directive.component[key]);
            }, 10),
            keys: directive.component
                ? __spread(Object.keys(directive.component).filter(function (key) {
                    return !(getPropDescriptor(directive.component, key).value instanceof EventEmitter ||
                        directive.component[key] instanceof EventEmitter);
                }), collectKeys(directive.component.__proto__, function (cmp, key) { return !(getPropDescriptor(cmp, key).value instanceof EventEmitter); }, 10)) : []
        };
        foundedInputs.parentKeys = __spread(foundedInputs.parentKeys, foundedInputs.parentKeys
            .map(function (parentKey) { return parentKey + '$'; })
            .filter(function (parentKey) {
            return foundedInputs.parentKeys.indexOf(parentKey) === -1 &&
                (directive.parentComponent[parentKey] instanceof ReplaySubject ||
                    directive.parentComponent[parentKey] instanceof Subject ||
                    directive.parentComponent[parentKey] instanceof BehaviorSubject);
        }));
        foundedInputs.keys = removeKeysUsedInAttributes(directive, foundedInputs.keys);
        foundedInputs.parentKeys = removeKeysUsedInAttributes(directive, foundedInputs.parentKeys);
        return foundedInputs;
    };
    /**
     * @param {?} directive
     * @return {?}
     */
    NgxBindInputsService.prototype.getIncludesAndExcludes = /**
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        /** @type {?} */
        var exclude = Array.isArray(directive.excludeInputs) ? directive.excludeInputs : [directive.excludeInputs];
        /** @type {?} */
        var include = Array.isArray(directive.includeInputs) ? directive.includeInputs : [directive.includeInputs];
        /** @type {?} */
        var includeIO = !directive.includeIO
            ? []
            : Array.isArray(directive.includeIO)
                ? directive.includeIO
                : [directive.includeIO];
        /** @type {?} */
        var excludeIO = !directive.excludeIO
            ? []
            : Array.isArray(directive.excludeIO)
                ? directive.excludeIO
                : [directive.excludeIO];
        /** @type {?} */
        var excludeInputs = __spread(exclude, excludeIO).map(function (key) { return key.toUpperCase(); });
        /** @type {?} */
        var includeInputs = __spread(include, includeIO).map(function (key) { return key.toUpperCase(); });
        return { includeInputs: includeInputs, excludeInputs: excludeInputs };
    };
    NgxBindInputsService.decorators = [
        { type: Injectable }
    ];
    return NgxBindInputsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBindIODebugService = /** @class */ (function () {
    function NgxBindIODebugService(_ngxBindInputsService) {
        this._ngxBindInputsService = _ngxBindInputsService;
    }
    /**
     * @param {?} directive
     * @param {?} debug
     * @return {?}
     */
    NgxBindIODebugService.prototype.showDebugInfo = /**
     * @param {?} directive
     * @param {?} debug
     * @return {?}
     */
    function (directive, debug) {
        var _this = this;
        /** @type {?} */
        var notExistsOutputs = [];
        /** @type {?} */
        var notExistsInputs = [];
        if (directive.outputs &&
            directive.component &&
            directive.component.__proto__ &&
            directive.component.__proto__.constructor &&
            directive.component.__proto__.constructor.ngBaseDef &&
            directive.component.__proto__.constructor.ngBaseDef.outputs) {
            /** @type {?} */
            var ngBaseDefOutputs = Object.keys(directive.component.__proto__.constructor.ngBaseDef.outputs);
            notExistsOutputs = removeKeysUsedInAttributes(directive, ngBaseDefOutputs).filter(function (ngBaseDefOutput) { return directive.outputs.keys.indexOf(ngBaseDefOutput) === -1; });
        }
        if (directive.inputs &&
            directive.component &&
            directive.component.__proto__ &&
            directive.component.__proto__.constructor &&
            directive.component.__proto__.constructor.ngBaseDef &&
            directive.component.__proto__.constructor.ngBaseDef.inputs) {
            /** @type {?} */
            var ngBaseDefInputs = Object.keys(directive.component.__proto__.constructor.ngBaseDef.inputs);
            notExistsInputs = removeKeysUsedInAttributes(directive, ngBaseDefInputs).filter(function (ngBaseDefInput) { return directive.inputs.keys.indexOf(ngBaseDefInput) === -1; });
        }
        if (debug || notExistsOutputs.length > 0 || notExistsInputs.length > 0) {
            if (debug) {
                console.group('NgxBindIO: debug');
            }
            else {
                console.group('NgxBindIO: warning');
            }
            console.log('Component:', directive.component.__proto__.constructor.name, directive.component);
            if (directive.usedOutputs) {
                console.log('Outputs maping:', Object.keys(directive.usedOutputs).map(function (parentKey) { return "(" + directive.usedOutputs[parentKey] + ")=\"" + parentKey + "($event)\""; }));
            }
            if (notExistsOutputs.length > 0) {
                console.log('Not initialized outputs:', notExistsOutputs);
                console.log('Not initialized outputs (text):', JSON.stringify(notExistsOutputs));
            }
            if (directive.usedInputs) {
                console.log('Inputs maping:', Object.keys(directive.usedInputs).map(function (parentKey) {
                    return _this._ngxBindInputsService.checkKeyNameToObservableInputBind(directive, parentKey, directive.usedInputs[parentKey])
                        ? "[" + directive.usedInputs[parentKey] + "]=\"" + parentKey + " | async\""
                        : "[" + directive.usedInputs[parentKey] + "]=\"" + parentKey + "\"";
                }));
            }
            if (notExistsInputs.length > 0) {
                console.log('Not initialized inputs:', notExistsInputs);
                console.log('Not initialized inputs (text):', JSON.stringify(notExistsInputs));
            }
            console.groupEnd();
        }
    };
    NgxBindIODebugService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NgxBindIODebugService.ctorParameters = function () { return [
        { type: NgxBindInputsService }
    ]; };
    return NgxBindIODebugService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BindInputsDirective = /** @class */ (function () {
    function BindInputsDirective(_ngxBindIOConfig, _viewContainerRef, _ngxBindInputsService, _ngxBindIODebugService, _ref) {
        this._ngxBindIOConfig = _ngxBindIOConfig;
        this._viewContainerRef = _viewContainerRef;
        this._ngxBindInputsService = _ngxBindInputsService;
        this._ngxBindIODebugService = _ngxBindIODebugService;
        this._ref = _ref;
        this.excludeInputs = [];
        this.includeInputs = [];
        this.inputs = {
            keys: [],
            parentKeys: []
        };
        this.usedInputs = {};
        this.destroyed$ = new Subject();
    }
    /**
     * @return {?}
     */
    BindInputsDirective.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.component = this._viewContainerRef['_data'].componentView.component;
        this.parentComponent = ((/** @type {?} */ (this._viewContainerRef)))._view.context;
        if (this.parentComponent.$implicit !== undefined) {
            this.parentComponent = ((/** @type {?} */ (this._viewContainerRef)))._view.component;
        }
        this.inputs = this._ngxBindInputsService.getInputs(this);
        this._ngxBindInputsService.bindInputs(this);
        this._ngxBindInputsService.bindObservableInputs(this);
        /** @type {?} */
        var debug = this._ngxBindIOConfig.debug ||
            (this.bindInputs && this.bindInputs.debug) ||
            (localStorage && localStorage.getItem('debug_ngx-bind-io') === 'true');
        this._ngxBindIODebugService.showDebugInfo(this, debug);
    };
    /**
     * @return {?}
     */
    BindInputsDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroyed$.next(true);
        this.destroyed$.complete();
    };
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    BindInputsDirective.prototype.bindValue = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        this.component[key] = value;
        this._ref.markForCheck();
    };
    BindInputsDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[bindInputs]'
                },] }
    ];
    /** @nocollapse */
    BindInputsDirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [NGX_BIND_IO_CONFIG,] }] },
        { type: ViewContainerRef },
        { type: NgxBindInputsService },
        { type: NgxBindIODebugService },
        { type: ChangeDetectorRef }
    ]; };
    BindInputsDirective.propDecorators = {
        bindInputs: [{ type: Input }],
        excludeInputs: [{ type: Input }],
        includeInputs: [{ type: Input }]
    };
    return BindInputsDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBindOutputsService = /** @class */ (function () {
    function NgxBindOutputsService() {
    }
    /**
     * BindOutputs Directive
     */
    /**
     * BindOutputs Directive
     * @param {?} directive
     * @return {?}
     */
    NgxBindOutputsService.prototype.bindOutputs = /**
     * BindOutputs Directive
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        var _this = this;
        /** @type {?} */
        var outputs = directive.outputs;
        var _a = this.getIncludesAndExcludes(directive), includeOutputs = _a.includeOutputs, excludeOutputs = _a.excludeOutputs;
        outputs.parentKeys
            .filter(function (parentKey) {
            return (includeOutputs.length === 0 && excludeOutputs.indexOf(parentKey.toUpperCase()) === -1) ||
                (includeOutputs.length !== 0 && includeOutputs.indexOf(parentKey.toUpperCase()) !== -1);
        })
            .forEach(function (parentKey) {
            outputs.keys
                .filter(function (key) {
                return (includeOutputs.length === 0 && excludeOutputs.indexOf(key.toUpperCase()) === -1) ||
                    (includeOutputs.length !== 0 && includeOutputs.indexOf(key.toUpperCase()) !== -1);
            })
                .forEach(function (key) {
                if (_this.checkOutputToBind(directive, parentKey, key)) {
                    _this.bindOutput(directive, parentKey, key);
                }
            });
        });
    };
    /**
     * Outputs
     */
    /**
     * Outputs
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindOutputsService.prototype.checkKeyNameToOutputBind = /**
     * Outputs
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        /** @type {?} */
        var outputs = directive.outputs;
        /** @type {?} */
        var keyWithFirstUpperLetter = key.length > 0 ? key.charAt(0).toUpperCase() + key.substr(1) : key;
        return ((parentKey === "on" + keyWithFirstUpperLetter &&
            outputs.parentKeys.indexOf("on" + keyWithFirstUpperLetter + "Click") === -1) ||
            parentKey === "on" + keyWithFirstUpperLetter + "Click");
    };
    /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindOutputsService.prototype.checkOutputToBind = /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        /** @type {?} */
        var value = getPropDescriptor(directive.component, key).value || directive.component[key];
        return (directive.usedOutputs[parentKey] === undefined &&
            value instanceof EventEmitter &&
            this.checkKeyNameToOutputBind(directive, parentKey, key));
    };
    /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    NgxBindOutputsService.prototype.bindOutput = /**
     * @param {?} directive
     * @param {?} parentKey
     * @param {?} key
     * @return {?}
     */
    function (directive, parentKey, key) {
        directive.usedOutputs[parentKey] = key;
        directive.component[key].subscribe(function (value) { return directive.parentComponent[parentKey](value); });
    };
    /**
     * Utils
     */
    /**
     * Utils
     * @param {?} directive
     * @return {?}
     */
    NgxBindOutputsService.prototype.getOutputs = /**
     * Utils
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        /** @type {?} */
        var foundedOutputs = {
            parentKeys: __spread(Object.keys(directive.parentComponent).filter(function (parentKey) { return isFunction(directive.parentComponent[parentKey]); }), collectKeys(directive.parentComponent.__proto__, function (cmp, key) { return isFunction(getPropDescriptor(cmp, key).value); }, 10)),
            keys: directive.component
                ? __spread(Object.keys(directive.component).filter(function (key) {
                    return getPropDescriptor(directive.component, key).value instanceof EventEmitter ||
                        directive.component[key] instanceof EventEmitter;
                }), collectKeys(directive.component.__proto__, function (cmp, key) { return getPropDescriptor(cmp, key).value instanceof EventEmitter; }, 10)) : []
        };
        foundedOutputs.keys = removeKeysUsedInAttributes(directive, foundedOutputs.keys);
        foundedOutputs.parentKeys = removeKeysUsedInAttributes(directive, foundedOutputs.parentKeys);
        return foundedOutputs;
    };
    /**
     * @param {?} directive
     * @return {?}
     */
    NgxBindOutputsService.prototype.getIncludesAndExcludes = /**
     * @param {?} directive
     * @return {?}
     */
    function (directive) {
        /** @type {?} */
        var exclude = Array.isArray(directive.excludeOutputs) ? directive.excludeOutputs : [directive.excludeOutputs];
        /** @type {?} */
        var include = Array.isArray(directive.includeOutputs) ? directive.includeOutputs : [directive.includeOutputs];
        /** @type {?} */
        var includeIO = !directive.includeIO
            ? []
            : Array.isArray(directive.includeIO)
                ? directive.includeIO
                : [directive.includeIO];
        /** @type {?} */
        var excludeIO = !directive.excludeIO
            ? []
            : Array.isArray(directive.excludeIO)
                ? directive.excludeIO
                : [directive.excludeIO];
        /** @type {?} */
        var excludeOutputs = __spread(exclude, excludeIO).map(function (key) { return key.toUpperCase(); });
        /** @type {?} */
        var includeOutputs = __spread(include, includeIO).map(function (key) { return key.toUpperCase(); });
        return { includeOutputs: includeOutputs, excludeOutputs: excludeOutputs };
    };
    NgxBindOutputsService.decorators = [
        { type: Injectable }
    ];
    return NgxBindOutputsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BindIODirective = /** @class */ (function () {
    function BindIODirective(_ngxBindIOConfig, _viewContainerRef, _ngxBindInputsService, _ngxBindOutputsService, _ngxBindIODebugService, _ref) {
        this._ngxBindIOConfig = _ngxBindIOConfig;
        this._viewContainerRef = _viewContainerRef;
        this._ngxBindInputsService = _ngxBindInputsService;
        this._ngxBindOutputsService = _ngxBindOutputsService;
        this._ngxBindIODebugService = _ngxBindIODebugService;
        this._ref = _ref;
        this.excludeIO = [];
        this.includeIO = [];
        this.excludeInputs = [];
        this.includeInputs = [];
        this.excludeOutputs = [];
        this.includeOutputs = [];
        this.inputs = {
            keys: [],
            parentKeys: []
        };
        this.outputs = {
            keys: [],
            parentKeys: []
        };
        this.usedInputs = {};
        this.usedOutputs = {};
        this.destroyed$ = new Subject();
    }
    /**
     * @return {?}
     */
    BindIODirective.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.component = this._viewContainerRef['_data'].componentView.component;
        this.parentComponent = ((/** @type {?} */ (this._viewContainerRef)))._view.context;
        if (this.parentComponent.$implicit !== undefined) {
            this.parentComponent = ((/** @type {?} */ (this._viewContainerRef)))._view.component;
        }
        this.inputs = this._ngxBindInputsService.getInputs(this);
        this.outputs = this._ngxBindOutputsService.getOutputs(this);
        this._ngxBindInputsService.bindInputs(this);
        this._ngxBindInputsService.bindObservableInputs(this);
        this._ngxBindOutputsService.bindOutputs(this);
        /** @type {?} */
        var debug = this._ngxBindIOConfig.debug ||
            (this.bindIO && this.bindIO.debug) ||
            (localStorage && localStorage.getItem('debug_ngx-bind-io') === 'true');
        this._ngxBindIODebugService.showDebugInfo(this, debug);
    };
    /**
     * @return {?}
     */
    BindIODirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroyed$.next(true);
        this.destroyed$.complete();
    };
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    BindIODirective.prototype.bindValue = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        this.component[key] = value;
        this._ref.markForCheck();
    };
    BindIODirective.decorators = [
        { type: Directive, args: [{
                    selector: '[bindIO]'
                },] }
    ];
    /** @nocollapse */
    BindIODirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [NGX_BIND_IO_CONFIG,] }] },
        { type: ViewContainerRef },
        { type: NgxBindInputsService },
        { type: NgxBindOutputsService },
        { type: NgxBindIODebugService },
        { type: ChangeDetectorRef }
    ]; };
    BindIODirective.propDecorators = {
        bindIO: [{ type: Input }],
        excludeIO: [{ type: Input }],
        includeIO: [{ type: Input }],
        excludeInputs: [{ type: Input }],
        includeInputs: [{ type: Input }],
        excludeOutputs: [{ type: Input }],
        includeOutputs: [{ type: Input }]
    };
    return BindIODirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BindOutputsDirective = /** @class */ (function () {
    function BindOutputsDirective(_ngxBindIOConfig, _viewContainerRef, _ngxBindOutputsService, _ngxBindIODebugService, _ref) {
        this._ngxBindIOConfig = _ngxBindIOConfig;
        this._viewContainerRef = _viewContainerRef;
        this._ngxBindOutputsService = _ngxBindOutputsService;
        this._ngxBindIODebugService = _ngxBindIODebugService;
        this._ref = _ref;
        this.excludeOutputs = [];
        this.includeOutputs = [];
        this.outputs = {
            keys: [],
            parentKeys: []
        };
        this.usedOutputs = {};
        this.destroyed$ = new Subject();
    }
    /**
     * @return {?}
     */
    BindOutputsDirective.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        this.component = this._viewContainerRef['_data'].componentView.component;
        this.parentComponent = ((/** @type {?} */ (this._viewContainerRef)))._view.context;
        if (this.parentComponent.$implicit !== undefined) {
            this.parentComponent = ((/** @type {?} */ (this._viewContainerRef)))._view.component;
        }
        this.outputs = this._ngxBindOutputsService.getOutputs(this);
        this._ngxBindOutputsService.bindOutputs(this);
        /** @type {?} */
        var debug = this._ngxBindIOConfig.debug ||
            (this.bindOutputs && this.bindOutputs.debug) ||
            (localStorage && localStorage.getItem('debug_ngx-bind-io') === 'true');
        this._ngxBindIODebugService.showDebugInfo(this, debug);
    };
    /**
     * @return {?}
     */
    BindOutputsDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.destroyed$.next(true);
        this.destroyed$.complete();
    };
    BindOutputsDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[bindOutputs]'
                },] }
    ];
    /** @nocollapse */
    BindOutputsDirective.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [NGX_BIND_IO_CONFIG,] }] },
        { type: ViewContainerRef },
        { type: NgxBindOutputsService },
        { type: NgxBindIODebugService },
        { type: ChangeDetectorRef }
    ]; };
    BindOutputsDirective.propDecorators = {
        bindOutputs: [{ type: Input }],
        excludeOutputs: [{ type: Input }],
        includeOutputs: [{ type: Input }]
    };
    return BindOutputsDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBindIOModule = /** @class */ (function () {
    function NgxBindIOModule() {
    }
    /**
     * @param {?=} options
     * @return {?}
     */
    NgxBindIOModule.forRoot = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return {
            ngModule: NgxBindIOModule,
            providers: [
                {
                    provide: NGX_BIND_IO_CONFIG,
                    useValue: {
                        debug: options ? options.debug : defaultNgxBindIOConfig.debug
                    }
                },
                NgxBindIODebugService,
                NgxBindInputsService,
                NgxBindOutputsService
            ]
        };
    };
    NgxBindIOModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [BindInputsDirective, BindOutputsDirective, BindIODirective],
                    exports: [BindInputsDirective, BindOutputsDirective, BindIODirective]
                },] }
    ];
    return NgxBindIOModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { defaultNgxBindIOConfig, NGX_BIND_IO_CONFIG, NgxBindIOModule, BindInputsDirective, BindIODirective, BindOutputsDirective, NgxBindInputsService, NgxBindIODebugService, NgxBindOutputsService, redefineSimpleProperty, redefineAccessorProperty, getPropDescriptor, isFunction, applyMixins, Mixin, collectKeys, removeKeysUsedInAttributes, getBindIOMetadata };

//# sourceMappingURL=ngx-bind-io.js.map